'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.SequencedAction = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _action = require('./action');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SequencedAction = exports.SequencedAction = function () {
    function SequencedAction(type, actions, errorHandlingAction, payloadReducer) {
        _classCallCheck(this, SequencedAction);

        this.type = type;
        this.actions = actions;
        this.payloadReducer = payloadReducer;
        this.errorHandler = errorHandlingAction;
        this.start = new _action.Action(type + '.START');
        this.end = new _action.Action(type + '.END');
    }

    _createClass(SequencedAction, [{
        key: 'reduce',
        value: function reduce() {
            if (this.payloadReducer) {
                return this.payloadReducer.apply(this, arguments);
            } else {
                return arguments.length <= 0 ? undefined : arguments[0];
            }
        }
    }, {
        key: 'payload',
        value: function payload() {
            var _this = this;

            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            return function (dispatch) {
                var _start;

                dispatch((_start = _this.start).payload.apply(_start, args));
                if (_this.actions && _this.errorHandler) {
                    var _loop = function _loop() {
                        var actionNo = i;
                        if (i < _this.actions.length - 1) {
                            _this.actions[actionNo].afterResponse = function (dispatch, res) {
                                dispatch(_this.actions[actionNo + 1].payload(_this.reduce.apply(_this, args)[actionNo + 1]));
                            };
                        } else {
                            _this.actions[actionNo].afterResponse = function (dispatch, res) {
                                var _end;

                                dispatch((_end = _this.end).payload.apply(_end, args));
                            };
                        }
                        _this.actions[i].afterError = function (dispatch, err) {
                            dispatch(_this.errorHandler.payload(err));
                        };
                    };

                    for (var i = 0; i < _this.actions.length; i++) {
                        _loop();
                    }
                }
                dispatch(_this.actions[0].payload(_this.reduce.apply(_this, args)[0]));
            };
        }
    }]);

    return SequencedAction;
}();